package ru.dbotthepony.mc.otm.menu.matter

import kotlin.jvm.JvmOverloads
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.block.entity.matter.MatterScannerBlockEntity
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.container.EnhancedContainer
import ru.dbotthepony.mc.otm.core.math.Decimal
import ru.dbotthepony.mc.otm.matter.MatterManager
import ru.dbotthepony.mc.otm.menu.MatteryPoweredMenu
import ru.dbotthepony.mc.otm.menu.MatteryMenuSlot
import ru.dbotthepony.mc.otm.menu.input.EnergyConfigPlayerInput
import ru.dbotthepony.mc.otm.menu.input.ItemConfigPlayerInput
import ru.dbotthepony.mc.otm.menu.makeUpgradeSlots
import ru.dbotthepony.mc.otm.menu.widget.ProfiledLevelGaugeWidget
import ru.dbotthepony.mc.otm.registry.game.MMenus

class MatterScannerMenu(
	containerID: Int,
	inventory: Inventory,
	tile: MatterScannerBlockEntity? = null
) : MatteryPoweredMenu(MMenus.MATTER_SCANNER, containerID, inventory, tile) {
	val input: MatteryMenuSlot
	val progress = ProgressGaugeWidget(this, tile)
	val patterns = LevelGaugeWidget(this)
	val itemConfig = ItemConfigPlayerInput(this, tile?.itemConfig)
	val energyConfig = EnergyConfigPlayerInput(this, tile?.energyConfig)
	val profiledEnergy = ProfiledLevelGaugeWidget(this, tile?.energy, energyWidget)
	val upgrades = makeUpgradeSlots(2, tile?.upgrades)

	init {
		val container = tile?.container ?: EnhancedContainer.Simple(1)

		input = object : MatteryMenuSlot(container, 0, 64, 38) {
			override fun mayPlace(itemStack: ItemStack) = MatterManager.canDecompose(itemStack)
		}

		addStorageSlot(input)

		if (tile != null) {
			patterns.with(
				{ Decimal(tile.matterNode.graph.patternCount) },
				{ Decimal(tile.matterNode.graph.patternCapacity) })
		}

		addInventorySlots()
	}
}
